--# main_program;
procedure SqrtMain
   --#  derives;
is
   subtype Sqrt_able is Natural range Natural'First .. 2 ** 30 - 1 ;
   -- massimo valore di X  per cui (X+1)*(X+1) <= Natural'Last
   --# function sqrt (N : Sqrt_able) return Natural;
   -- Th1: N*N >= sqrt(N);
   -- Th2: sqrt(N) < (N+1)*(N+1);
   -- Th3: 0 <= N <= Sqrt_able'Last -> introot(N) = sqrt(N);
   function IntRoot (N : Sqrt_able) return Natural
      --# return Root => ( (Root * Root <= N) and
      --#                  (N < (Root + 1) * (Root + 1)) );
   is
      R : Natural := 0;
      S, T : Natural := 1;
   begin
      loop
      --# assert (T = 2 * R + 1) and
      --# (S = (R + 1) * (R + 1)) and
      --# (R * R <= N);
         exit when S > N ;

         R := R + 1;
         T := T + 2;
         S := S + T;
      end loop;
      return R;
   end IntRoot;

   procedure Call(N: in Natural; R : out Natural)
   --# derives R from N;
   --# post ( (R * R <= N) and
   --#        (N < (R + 1) * (R + 1)) );
   is
   begin
      R := IntRoot(N);
   end Call;

   procedure Call2(N: in Natural; R : out Natural)
   --# derives R from N;
   --# post (N <= Sqrt_able'Last and R = sqrt(N)) or
   --#      (N > Sqrt_able'Last and R = Natural'Last);
   is
   begin
      if N <= Sqrt_able'Last
      then
         R := IntRoot(N);
      else
         R := Natural'Last;
      end if;
   end Call2;

begin
   null;
end SqrtMain;
